﻿@page "/users/profile/{userId:guid?}"

@using Microsoft.EntityFrameworkCore
@using Microsoft.Extensions.Localization
@using OWebApplication.Operators
@using System.Threading
@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IJSRuntime _jsRuntime
@inject IStringLocalizer<Profile> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject IDialogService _dialogService
@inject ISnackbar _snackbar

<MudContainer MaxWidth="MaxWidth.Small">
    <MudPaper Outlined="true" class="d-flex justify-start align-center pa-3 mb-3">
        @* User's avatar *@
        <div>
            @if (_viewedUserInfo is null)
            {
                <MudSkeleton SkeletonType="SkeletonType.Circle" Class="ma-2" Style="width: 80px !important; height: 80px !important;"/>
            }
            else
            {
                <MudAvatar Class="@($"ma-2 {(_viewedUserInfo.IsCurrentlyOnline ? "user-avatar-online" : string.Empty)}")"
                           Style="height: 80px; width: 80px; font-size: 2rem;" Color="Color.Primary">@_viewedUserInfo.FullName.First()</MudAvatar>
                <!--suppress CssUnusedSymbol -->
                <style>
                    .user-avatar-online {
                        border: 2px #00c853ff solid;
                    }
                </style>
            }
        </div>
        @* /User's avatar *@
        
        @* User's fullname and institution name *@
        <div class="pl-2" style="flex-grow: 1; overflow: hidden;">
            @if (_viewedUserInfo is null)
            {
                <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="60px;"/>
            }
            else
            {
                <MudText Class="ma-0" Typo="Typo.h5" Style="font-weight: bold; overflow: hidden; white-space: nowrap; text-overflow: ellipsis;">@_viewedUserInfo.FullName</MudText>
                <MudText Class="ma-0" Typo="Typo.subtitle1" Style="overflow: hidden; white-space: nowrap; text-overflow: ellipsis;">@(_viewedUserInfo.InstitutionName ?? _localizer["Користувач системи"])</MudText>
            }
        </div>
        @* /User's fullname and institution name *@
        
        @* User's options menu *@
        <MudMenu Icon="@Icons.Material.Filled.MoreVert" AnchorOrigin="@Origin.BottomRight" TransformOrigin="Origin.TopRight">
            @if (_viewedUserInfo is not null && _viewedUserInfo.UserType != UserType.Student)
            {
                <MudMenuItem OnClick="@(() => _navigationManager.NavigateTo($"/Users/Rating/?curator={UserId}"))"
                             Icon="@Icons.Material.Filled.SupervisedUserCircle">@_localizer["Підлеглі та студенти"]</MudMenuItem>
                
                <MudDivider/>
            }
            
            @if (_isCurrentUserHasAdminAccess)
            {
                <MudMenuItem OnClick="@(() => _navigationManager.NavigateTo($"/Users/Profile/Edit/{UserId}"))"
                             Icon="@Icons.Material.Filled.Settings">@_localizer["Налаштування"]</MudMenuItem>

                @if (UserId != _currentUserId)
                {
                    <MudDivider/>

                    <MudMenuItem OnClick="@(() => _snackbar.Add(_localizer["Coming soon!"], Severity.Warning))"
                                 Icon="@Icons.Material.Filled.RemoveDone">@_localizer["Видалити усі розв'язки"]</MudMenuItem>
                    <MudMenuItem OnClick="DeleteUserAsync" Icon="@Icons.Material.Filled.DeleteForever"
                                 >@_localizer["Видалити користувача"]</MudMenuItem>
                }
            }
        </MudMenu>
        @* /User's options menu *@
    </MudPaper>
    
    <MudTabs Outlined="true" Centered="true" Rounded="true" ApplyEffectsToContainer="true">
        <MudTabPanel Icon="@Icons.Material.Filled.Info" Text="@_localizer["Інформація"]">
            @* User information list *@
            <MudList Clickable="true">
                @if (_viewedUserInfo == null)
                {
                    for (var i = 0; i < 7; i++)
                    {
                        <MudListItem>
                            <MudSkeleton SkeletonType="SkeletonType.Rectangle" class="mt-0 mb-1" Width="100%" Height="20px"/>
                            <MudSkeleton SkeletonType="SkeletonType.Rectangle" class="ma-0" Width="100%" Height="15px"/>
                        </MudListItem>
                    }
                }
                else
                {
                    <MudListItem>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Повне ім'я:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_viewedUserInfo.FullName</MudText>
                    </MudListItem>
                    <MudListItem>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Навчальний заклад:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@(_viewedUserInfo.InstitutionName ?? _localizer["Не вказано"])</MudText>
                    </MudListItem>
                    <MudListItem OnClick="@(async () => await OpenLinkAsync($"mailto://{_viewedUserInfo.Email}"))">
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Електронна пошта:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_viewedUserInfo.Email</MudText>
                    </MudListItem>
                    
                    <MudDivider/>
                    
                    <MudListItem>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Унікальний ідентифікатор:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@UserId.ToString()</MudText>
                    </MudListItem>
                    
                    <MudListItem OnClick="@(() => _navigationManager.NavigateTo($"/Users/Profile/{(_viewedUserInfo.CuratorId.HasValue ? _viewedUserInfo.CuratorId.ToString() : UserId.ToString())}"))">
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Куратор:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">
                            @if (_viewedUserInfo.CuratorId is null)
                            {
                                <span>@_localizer["Користувач не має куратора."]</span>
                            }
                            else
                            {
                                <span>@_viewedUserInfo.CuratorFullName</span>
                            }
                        </MudText>
                    </MudListItem>

                    <MudDivider/>

                    <MudListItem>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Востаннє онлайн:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_viewedUserInfo.LastSeen</MudText>
                    </MudListItem>
                    <MudListItem>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Дата і час реєстрації:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_viewedUserInfo.Registered</MudText>
                    </MudListItem>
                }
            </MudList>
            @* /User information list *@
        </MudTabPanel>
        
        <MudTabPanel Icon="@Icons.Material.Filled.QueryStats" Text="@_localizer["Статистика"]">
            <MudText Class="ma-4">Coming soon</MudText>
        </MudTabPanel>
    </MudTabs>
</MudContainer>

@code {
    [Parameter]
    public Guid? UserId { get; set; }

    private SemaphoreSlim _semaphore;
    private UserInformationModel _viewedUserInfo;
    private Guid? _currentUserId;
    private bool _isCurrentUserHasAdminAccess;

    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        _semaphore = new SemaphoreSlim(1, 1);
        var authenticationState = await _authenticationStateProvider.GetAuthenticationStateAsync();
        _currentUserId = new Guid(_userManager.GetUserId(authenticationState.User));
        _viewedUserInfo = null;
    }

    protected override async Task OnParametersSetAsync()
    {
        UserId ??= _currentUserId;
        _isCurrentUserHasAdminAccess = false;
        _viewedUserInfo = null;
        
        await GetUserInformationAsync();
        StateHasChanged();
    }

    private async Task GetUserInformationAsync()
    {
        await _semaphore.WaitAsync();
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();

            if (!await databaseContext.Users.AsNoTracking().AnyAsync(u => u.Id == UserId))
            {
                _snackbar.Add(_localizer["Користувача із заданим ідентифікатором не знайдено!"], Severity.Error, options =>
                {
                    options.RequireInteraction = true;
                });
                _navigationManager.NavigateTo("/");
                return;
            }

            _viewedUserInfo = await databaseContext.Users.AsNoTracking()
                .Include(i => i.Curator)
                .Where(u => u.Id == UserId)
                .Select(s => new UserInformationModel
                {
                    FullName = s.FullName,
                    InstitutionName = s.InstitutionName,

                    Email = s.Email,
                    UserType = s.Type,

                    CuratorId = s.CuratorId,
                    CuratorFullName = s.Curator.FullName,

                    Registered = s.Registered,
                    LastSeen = s.LastSeen
                }).FirstAsync();

            _viewedUserInfo.IsCurrentlyOnline = (DateTime.UtcNow - _viewedUserInfo.LastSeen) <= new TimeSpan(0, 5, 0);

            _isCurrentUserHasAdminAccess = await _userAccessControlOperator.HasEditPrivillegesAsync(databaseContext,
                _currentUserId.GetValueOrDefault(), UserId.GetValueOrDefault());
        }
        finally { _semaphore.Release(); }
    }
    
    private async Task DeleteUserAsync()
    {
        if (!_isCurrentUserHasAdminAccess || UserId == _currentUserId)
            return;
        
        var result = await _dialogService.ShowMessageBox(
            _localizer["Підтвердження операції"], 
            _localizer[
                "Ви збираєтеся видалити цього користувача, а також усі пов'язані з ним дані, включно з надісланими розв'язками, інформацією про участь у змаганнях, тощо. " +
                "Ця дія є цілком незворотньою! Чи підтверджуєте ви бажання здійснити цю операцію?"], 
            options: new DialogOptions
            {
                Position = DialogPosition.Center,
                DisableBackdropClick = true,
                MaxWidth = MaxWidth.Small
            }, yesText: _localizer["Видалити"], cancelText: _localizer["Відмінити"]);

        if (result is null or false)
        {
            _snackbar.Add(_localizer["Операцію відхилено, користувача збережено."], Severity.Info);
            return;
        }
        
        await using var databaseContext = _dbContextFactory.CreateDbContext();

        var userObject = await databaseContext.Users.FirstAsync(u => u.Id == UserId);
        databaseContext.Users.Remove(userObject);
        await databaseContext.SaveChangesAsync();
        
        _navigationManager.NavigateTo("/", true);
    }
    
    private async Task OpenLinkAsync(string url)
    {
        await _jsRuntime.InvokeAsync<object>("open", url, "_blank");
    }
    
    private class UserInformationModel
    {
        public string FullName { get; init; }
        public string InstitutionName { get; init; }
        
        public string Email { get; init; }
        public UserType UserType { get; init; }
        
        public Guid? CuratorId { get; init; }
        public string CuratorFullName { get; init; }
        
        public DateTime Registered { get; init; }
        public DateTime LastSeen { get; init; }
        
        public bool IsCurrentlyOnline { get; set; }
    }
}